#include <array.au3>

; bereitet eine Zahlentabelle vor. Diese kann eine Anzahl von [<Wert in der eckigen Klammer>] Zahlen fassen
Dim $aZahlenTabelle[30]


; Fülle die Zahlentabelle
; "UBound" listet die Anzahl der Elemente in der Tabelle. Blöderweise fängt die Tabelle aber bei 0 an und nicht bei 1
; Wenn wir also von dem von "UBound" errechneten Wert nicht 1 wieder abziehen würden, würde die Schleife als Letztes
; versuchen, 1 Element mehr in die Tabelle zu schreiben, als diese fassen kann. Probiers aus, entferne das "-1" ;)
For $i = 0 To UBound($aZahlenTabelle) - 1
	$aZahlenTabelle[$i] = $i + 1
Next


; Zeige die Zahlentabelle an
_ArrayDisplay($aZahlenTabelle, "Zahlentabelle direkt nach Erzeugung")


; Erstelle eine Tabelle mit den nicht benötigten Zahlen, wie sie aus der Datei "Muell.ini" ausgelesen wurden
$aMuell = FileReadToArray(@ScriptDir & "\muell.ini")
If @error Then
	MsgBox(64, "Fehler", "Datei mit den nicht benötigten Zahlen nicht gefunden oder nicht lesbar. Bitte korrigieren.")
	Exit
EndIf
_ArraySort($aMuell, 1)	; wir sortieren die Tabelle der nicht benötigten Zahlen noch von Groß nach Klein, damit später
						; beim Entfernen der nicht benötigten Zahlen die richtigen Zahlen entfernt werden


; gleiche die $aZahlenTabelle mit der $aMuell Tabelle ab und entferne nicht benötigten Zahlen aus der $aZahlenTabelle
For $i = 0 To UBound($aMuell) - 1
	_ArrayDelete($aZahlenTabelle, $aMuell[$i] - 1)
Next


; Zeige die Zahlentabelle nach Entfernen der nicht benötigten Zahlen an
_ArrayDisplay($aZahlenTabelle, "Zahlentabelle nach Ausschluss der nicht benötigten Zahlen")


; Wähle aus dem, was in der Zahlentabelle noch übrig ist, eine zufällige Zahl aus, zeige sie dem Benutzer an und lösche sie aus der Zahlentabelle
For $i = 0 To UBound($aZahlenTabelle) - 1
	If UBound($aZahlenTabelle) = 0 Then ExitLoop ; beende die Schleife, wenn die Anzahl der Elements in $aZahlenTabelle 0 ist. Andernfalls gibts 'ne Fehlermeldung
	$Tabellenposition = Random(0, UBound($aZahlenTabelle) - 1, 1) ; Hier herrscht der Zufall; aus den in der $aZahlenTabelle verbliebenen Werten wird einer zufällig ausgewählt...
	MsgBox(0, "Zufallszahl!", $aZahlenTabelle[$Tabellenposition]) ; ... angezeigt ...
	_ArrayDelete($aZahlenTabelle, $Tabellenposition) ; ... und abschließend aus der $aZahlenTabelle entfernt
Next
